function varargout=plotNodesNumber(q,varargin)
  p = inputParser; 
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('toGlobal',[]); 
  p.addParamValue('BackgroundColor','w');
  p.addParamValue('margin',1);
  p.addParamValue('D',[]);
  p.addParamValue('FontSize',5);
  p.addParamValue('HorizontalAlignment','center');
  p.addParamValue('VerticalAlignment','middle');
  p.addParamValue('clipping','on');
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  varargin={varargin{:},'BackgroundColor',fc_tools.graphics.xcolor.val2rgb(R.BackgroundColor), ...
                        'margin',R.margin, 'FontSize',R.FontSize, ...
                        'HorizontalAlignment',R.HorizontalAlignment, ...
                        'VerticalAlignment',R.VerticalAlignment, ...
                        'clipping',R.clipping};
  [dim,nq]=size(q);
  iq=1:nq;
  if isempty(R.D)
    D=zeros(1,max(2,dim));  
  else
    assert(length(R.D)==max(2,dim))
    D=R.D;
  end
  if ~isempty(R.toGlobal), strNum=num2str(toGlobal); else  strNum=num2str(iq');end
  switch dim
    case 1
      h=text(q(1,iq)+D(1),0*q(1,iq)+D(2),strNum,varargin{:});
    case 2
      h=text(q(1,iq)+D(1),q(2,iq)+D(2),strNum,varargin{:});
    case 3
      h=text(q(1,iq)+D(1),q(2,iq)+D(2),q(3,iq)+D(3),strNum, varargin{:});
    otherwise
      warning('Unable to plot in space dimension %d',dim);h=[]; 
  end
  if nargout==1, varargout{1}=h;end
  leg=sprintf('Vert. num');
  if nargout>=1, varargout{1}=h;end
  if nargout==2, varargout{2}=leg;end
end
